api/urls.py
urlpatterns = [

]

inv/urls.py
from django.urls import path

from inv.models import SubCategoria, UnidadMedida

from .views import CategoriaView, CategoriaNew, CategoriaEdit, CategoriaDel, MarcaView, \
    SubCategoriaView, SubCategoriaNew, SubCategoriaEdit, SubCategoriaDel, \
        MarcaView, MarcaNew, MarcaEdit, marca_inactivar, \
            UMView, UMNew, UMEdit, um_inactivar, \
                ProductoView, ProductoNew, ProductoEdit, producto_inactivar
            

urlpatterns = [
    path('categorias/', CategoriaView.as_view(), name='categoria_list'),
    path('categorias/new', CategoriaNew.as_view(), name='categoria_new'),
    path('categorias/edit/<int:pk>', CategoriaEdit.as_view(), name='categoria_edit'),
    path('categorias/delete/<int:pk>', CategoriaDel.as_view(), name='categoria_del'),

    path('subcategorias/', SubCategoriaView.as_view(), name='subcategoria_list'),
    path('subcategorias/new', SubCategoriaNew.as_view(), name='subcategoria_new'),
    path('subcategorias/edit/<int:pk>', SubCategoriaEdit.as_view(), name='subcategoria_edit'),
    path('subcategorias/delete/<int:pk>', SubCategoriaDel.as_view(), name='subcategoria_del'),

    path('marcas/', MarcaView.as_view(), name='marca_list'),
    path('marcas/new', MarcaNew.as_view(), name='marca_new'),
    path('marcas/edit/<int:pk>', MarcaEdit.as_view(), name='marca_edit'),
    path('marcas/inactivar/<int:id>', marca_inactivar, name='marca_inactivar'),

    path('um/', UMView.as_view(), name='um_list'),
    path('um/new', UMNew.as_view(), name='um_new'),
    path('um/edit/<int:pk>', UMEdit.as_view(), name='um_edit'),
    path('um/inactivar/<int:id>', um_inactivar, name='um_inactivar'),

    path('producto/', ProductoView.as_view(), name='producto_list'),
    path('producto/new', ProductoNew.as_view(), name='producto_new'),
    path('producto/edit/<int:pk>', ProductoEdit.as_view(), name='producto_edit'),
    path('producto/inactivar/<int:id>', producto_inactivar, name='producto_inactivar'),    
]

syscofa/urls.py
from argparse import Namespace
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include(('bases.urls', 'bases'), namespace='bases')),
    path('inv/', include(('inv.urls', 'inv'), namespace='inv')),
    path('cmp/', include(('cmp.urls', 'cmp'), namespace='cmp')),
    path('fac/', include(('fac.urls', 'fac'), namespace='fac')),
    path('api/', include(('api.urls', 'api'), namespace='api')),
    path('admin/', admin.site.urls),
    path('api-auth/', include('rest_framework.urls')),    
]

bases/models.py
from tkinter import CASCADE
from django.db import models
from django.contrib.auth.models import User
from django_userforeignkey.models.fields import UserForeignKey

# Create your models here.
class ClaseModelo(models.Model):
    estado = models.BooleanField(default=True)
    fc = models.DateTimeField(auto_now_add=True) #fecha de creación
    fm = models.DateTimeField(auto_now=True)     #fecha de modificación
    uc = models.ForeignKey(User, on_delete=models.CASCADE) #usuario de creación
    um = models.IntegerField(blank=True, null=True) #usuario de modificación

    class Meta:
        # se ignora este modelo al momento de hacer las migraciones
        abstract=True

class ClaseModelo2(models.Model):
    estado = models.BooleanField(default=True)
    fc = models.DateTimeField(auto_now_add=True) #fecha de creación
    fm = models.DateTimeField(auto_now=True)     #fecha de modificación
    # uc = models.ForeignKey(User, on_delete=models.CASCADE) #usuario de creación
    # um = models.IntegerField(blank=True, null=True) #usuario de modificación
    uc = UserForeignKey(auto_user_add=True, related_name='+')
    um = UserForeignKey(auto_user=True, related_name='+')

    class Meta:
        # se ignora este modelo al momento de hacer las migraciones
        abstract=True

inv/models.py
from re import T
from tabnanny import verbose
from tkinter import CASCADE
from django.db import models
from bases.models import ClaseModelo

# Create your models here.
class Categoria(ClaseModelo):
    """ modelo Categoría"""
    descripcion = models.CharField(
        max_length=100,
        help_text='Descripción de la categoría',
        unique=True
    )

    def __str__(self):
        """ Descripción del modelo categoria"""
        return '{}'.format(self.descripcion)

    def save(self):
        """ el valor de categoría lo guardamos en mayusculas"""
        self.descripcion = self.descripcion.upper()
        super(Categoria, self).save()

    class Meta:
        """ nombre en plural(Muchos) del modelo"""
        verbose_name_plural = "Categorias"

class SubCategoria(ClaseModelo):
    """ modelo SubCategoría"""
    categoria = models.ForeignKey(Categoria, on_delete=models.CASCADE)
    descripcion = models.CharField(
        max_length=100,
        help_text="Descripción de la categoria",        
    )

    def __str__(self):
        return '{}:{}'.format(self.categoria.descripcion, self.descripcion)

    def save(self):
        """ el valor de subcategoría lo guardamos en mayúsculas"""
        self.descripcion = self.descripcion.upper()
        super(SubCategoria, self).save()

    class Meta:
        """ nombre en plural(Muchos) del modelo"""
        verbose_name_plural = "Sub Categorias"
        unique_together = ('categoria','descripcion')

class Marca(ClaseModelo):
    """ modelo Marca"""
    descripcion = models.CharField(
        max_length=100,
        help_text="Descripción de la marca",
        unique=True
    )

    def __str__(self):
        """ descripción del modelo marca"""
        return '{}'.format(self.descripcion)

    def save(self):
        """ el valor de marca lo guardamos en mayusculas"""
        self.descripcion = self.descripcion.upper()
        super(Marca, self).save()

    class Meta:
        """ nombre en plural(Muchos) del modelo"""
        verbose_name_plural = "Marcas"

class UnidadMedida(ClaseModelo):
    """ modelo Unidad de Medida"""
    descripcion = models.CharField(
        max_length=100,
        help_text="Descripción de la Unidad de Medida",
        unique=True
    )

    def __str__(self):
        return '{}'.format(self.descripcion)

    def save(self):
        """ el valor de Unidad de Medida lo guardamos en mayúsculas"""
        self.descripcion = self.descripcion.upper()
        super(UnidadMedida, self).save()
    class Meta:
        """ nombre en plural(Muchos) del modelo"""
        verbose_name_plural = "Unidades de Medida"

class Producto(ClaseModelo):
    """ modelo Producto"""
    codigo = models.CharField(
        max_length=20,
        unique=True
    )
    codigo_barra = models.CharField(max_length=50)
    descripcion = models.CharField(max_length=200)
    precio = models.FloatField(default=0)
    existencia = models.IntegerField(default=0)
    ultima_compra = models.DateField(null=True, blank=True) 

    # llaves foraneas
    marca = models.ForeignKey(Marca, on_delete=models.CASCADE)
    unidad_medida = models.ForeignKey(UnidadMedida, on_delete=models.CASCADE)
    subcategoria = models.ForeignKey(SubCategoria, on_delete=models.CASCADE)

    def __str__(self):
        """ descripción de producto"""
        return '{}'.format(self.descripcion)

    def save(self):
        """ el valor de Producto lo guardamos en mayúsculas"""
        self.descripcion = self.descripcion.upper()
        super(Producto, self).save()
    class Meta:        
        """ nombre en plural(Muchos) del modelo"""
        verbose_name_plural = "Productos"
        unique_together = ('codigo', 'codigo_barra')

inv/views.py
from pyexpat import model
from re import template
from django.shortcuts import render, redirect
from django.views import generic
from django.urls import reverse_lazy
from django.contrib import messages

from django.contrib.auth.mixins import LoginRequiredMixin, PermissionRequiredMixin
from django.contrib.messages.views import SuccessMessageMixin
from django.contrib.auth.decorators import login_required, permission_required

from .models import Categoria, SubCategoria, Marca, UnidadMedida, Producto
from .forms import CategoriaForm, SubCategoriaForm, MarcaForm, UMForm, ProductoForm
from bases.views import Sin_Privilegios

# Create your views here.
class CategoriaView(Sin_Privilegios, generic.ListView):
    """ vista basada en clase que lista las categorías"""
    permission_required = 'inv.view_categoria'
    model = Categoria
    template_name = "inv/categoria_list.html"
    context_object_name = "obj"

class CategoriaNew(SuccessMessageMixin, Sin_Privilegios, generic.CreateView):
    """ vista basada en clase para crear una nueva categoría"""
    permission_required = 'inv.add_categoria'
    model = Categoria
    template_name = "inv/categoria_form.html"
    context_object_name = "obj"
    form_class =  CategoriaForm #formulario a utilizar
    success_message = "Categoría creada satisfactoriamente"
    success_url = reverse_lazy("inv:categoria_list") #redireccionamos a la lista de categorías
   
    def form_valid(self, form):
        form.instance.uc = self.request.user #ubicamos al usuario que creo el formulario
        return super().form_valid(form)

class CategoriaEdit(SuccessMessageMixin, Sin_Privilegios, generic.UpdateView):    
    """ vista basada en clase para editar y/o actualizar una categoría"""
    permission_required = 'inv.change_categoria'
    model = Categoria
    template_name = "inv/categoria_form.html"
    context_object_name = "obj"
    form_class =  CategoriaForm #formulario a utilizar
    success_message = "Categoría actualizada satisfactoriamente"
    success_url = reverse_lazy("inv:categoria_list") #redireccionamos a la lista de categorías
    
    def form_valid(self, form):
        form.instance.um = self.request.user.id #ubicamos al usuario que modificó el formulario
        return super().form_valid(form)

class CategoriaDel(SuccessMessageMixin, Sin_Privilegios, generic.edit.DeleteView):
    """ vista basada en clase para eliminar una categoría"""
    permission_required = 'inv.delete_categoria'
    model = Categoria
    template_name = "inv/categoria_del.html"
    context_object_name = "obj"
    success_message = "Categoría eliminada satisfactoriamente"
    success_url = reverse_lazy("inv:categoria_list")
    
class SubCategoriaView(Sin_Privilegios, generic.ListView):
    """ vista basada en clase que lista las subcategorías"""
    permission_required = "inv.view_subcategoria"
    model = SubCategoria
    template_name = "inv/subcategoria_list.html"
    context_object_name = "obj"

class SubCategoriaNew(SuccessMessageMixin, Sin_Privilegios, generic.CreateView):
    """ vista basada en clase para crear una nueva subcategoría"""
    permission_required = "inv.add_subcategoria"
    model = SubCategoria
    template_name = "inv/subcategoria_form.html"
    context_object_name = "obj"
    form_class =  SubCategoriaForm #formulario a utilizar
    succes_message = "Sub Categoría creada correctamente"
    success_url = reverse_lazy("inv:subcategoria_list") #redireccionamos a la lista de subcategorías

    def form_valid(self, form):
        form.instance.uc = self.request.user #ubicamos al usuario que creo el formulario
        return super().form_valid(form)

class SubCategoriaEdit(SuccessMessageMixin, Sin_Privilegios, generic.UpdateView):    
    """ vista basada en clase para editar y/o actualizar una subcategoría"""
    permission_required = "inv.change_subcategoria"
    model = SubCategoria
    template_name = "inv/subcategoria_form.html"
    context_object_name = "obj"
    form_class =  SubCategoriaForm #formulario a utilizar
    succes_message = "Sub Categoría actualizada correctamente"
    success_url = reverse_lazy("inv:subcategoria_list") #redireccionamos a la lista de subcategorías
    
    def form_valid(self, form):
        form.instance.um = self.request.user.id #ubicamos al usuario que modificó el formulario
        return super().form_valid(form)

class SubCategoriaDel(SuccessMessageMixin, Sin_Privilegios, generic.edit.DeleteView):
    """ vista basada en clase para eliminar una subcategoría"""
    model = SubCategoria
    template_name = "inv/catalogos_del.html"
    context_object_name = "obj"
    success_url = reverse_lazy("inv:subcategoria_list")
    succes_message = "Sub Categoría eliminada correctamente"
    permission_required = "inv.delete_subcategoria"

class MarcaView(Sin_Privilegios, generic.ListView):
    """ vista basada en clase que lista las marcas"""
    permission_required = 'inv.view_marca'
    model = Marca
    template_name = "inv/marca_list.html"
    context_object_name = "obj"

class MarcaNew(SuccessMessageMixin, Sin_Privilegios, generic.CreateView):
    """ vista basada en clase para crear una nueva marca"""
    model = Marca
    template_name = "inv/marca_form.html"
    context_object_name = "obj"
    form_class =  MarcaForm #formulario a utilizar
    success_url = reverse_lazy("inv:marca_list") #redireccionamos a la lista de marcas
    succes_message = "Marca creada correctamente"
    permission_required = "inv.add_marca"

    def form_valid(self, form):
        form.instance.uc = self.request.user #ubicamos al usuario que creo el formulario
        return super().form_valid(form)

class MarcaEdit(SuccessMessageMixin, Sin_Privilegios, generic.UpdateView):    
    """ vista basada en clase para editar y/o actualizar una marca"""
    model = Marca
    template_name = "inv/marca_form.html"
    context_object_name = "obj"
    form_class =  MarcaForm #formulario a utilizar
    success_url = reverse_lazy("inv:marca_list") #redireccionamos a la lista de marcas
    succes_message = "Marca actualizada correctamente"
    permission_required = "inv.change_marca"

    def form_valid(self, form):
        form.instance.um = self.request.user.id #ubicamos al usuario que modificó el formulario
        return super().form_valid(form)

@login_required(login_url='/login/') #debo estar logeado
@permission_required('inv.change_marca', login_url='bases:sin_privilegios') #y tener permiso para modificar
def marca_inactivar(request, id):
    """ vista que inactiva una marca"""
    marca = Marca.objects.filter(pk=id).first()
    contexto = {}
    template_name="inv/marca_inactivar.html"

    if not marca:
        return redirect("inv:marca_list")

    if request.method == 'GET':
        contexto = {'obj': marca}

    if request.method == 'POST':
        marca.estado = False
        marca.save()
        messages.success (request, 'Marca Inactivada')
        return redirect('inv:marca_list')

    return render(request, template_name, contexto)

class UMView(Sin_Privilegios, generic.ListView):
    """ vista basada en clase que lista las unidades de medida"""
    model = UnidadMedida
    template_name = "inv/um_list.html"
    context_object_name = "obj"
    permission_required = "inv.view_unidadmedida"

class UMNew(SuccessMessageMixin, Sin_Privilegios, generic.CreateView):
    """ vista basada en clase para crear una nueva unidad de medida"""
    model = UnidadMedida
    template_name = "inv/um_form.html"
    context_object_name = "obj"
    form_class =  UMForm #formulario a utilizar
    success_url = reverse_lazy("inv:um_list") #redireccionamos a la lista de unidades de medida
    succes_message = "Unidad de Medida creada correctamente"
    permission_required = "inv.add_unidadmedida"

    def form_valid(self, form):
        form.instance.uc = self.request.user #ubicamos al usuario que creo el formulario
        return super().form_valid(form)

class UMEdit(SuccessMessageMixin, Sin_Privilegios, generic.UpdateView):    
    """ vista basada en clase para editar y/o actualizar una unidad de medida"""
    model = UnidadMedida
    template_name = "inv/um_form.html"
    context_object_name = "obj"
    form_class =  UMForm #formulario a utilizar
    success_url = reverse_lazy("inv:um_list") #redireccionamos a la lista de unidades de medida
    succes_message = "Unidad de Medida actualizada correctamente"
    permission_required = "inv.change_unidadmedida"

    def form_valid(self, form):
        form.instance.um = self.request.user.id #ubicamos al usuario que modificó el formulario
        return super().form_valid(form)

@login_required(login_url='/login/')
@permission_required('inv.change_unidadmedida', login_url='bases:sin_privilegios')
def um_inactivar(request, id):
    """ vista que inactiva una unidad de medida"""
    um = UnidadMedida.objects.filter(pk=id).first()
    contexto = {}
    template_name="inv/um_inactivar.html"

    if not um:
        return redirect("inv:um_list")

    if request.method == 'GET':
        contexto = {'obj': um}

    if request.method == 'POST':
        um.estado = False
        um.save()
        return redirect('inv:um_list')

    return render(request, template_name, contexto)

class ProductoView(Sin_Privilegios, generic.ListView):
    """ vista basada en clase que lista los productos"""
    model = Producto
    template_name = "inv/producto_list.html"
    context_object_name = "obj"
    permission_required = "inv.view_producto"

class ProductoNew(SuccessMessageMixin, Sin_Privilegios, generic.CreateView):
    """ vista basada en clase para crear una nuevo producto"""
    model = Producto
    template_name = "inv/producto_form.html"
    context_object_name = "obj"
    form_class =  ProductoForm #formulario a utilizar
    success_url = reverse_lazy("inv:producto_list") #redireccionamos a la lista de productos
    succes_message = "Producto creado correctamente"
    permission_required = "inv.add_producto"

    def form_valid(self, form):

inv/templates/inv/categoria_list.html
{% extends 'base/base.html' %}

{% block page_content %}
 <!-- Dropdown Card Example -->
 <div class="card shadow mb-4">
    <!-- Card Header - Dropdown -->
    <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
        <h6 class="m-0 font-weight-bold text-primary">Listado de Categorías</h6>
        <div class="dropdown no-arrow">
            <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
            </a>
            <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
                <div class="dropdown-header">Acciones:</div>
                    <a class="dropdown-item" href="{% url 'inv:categoria_new' %}"> <i class="fa fa-calendar-plus"></i> Nueva</a>
                    <!-- <a class="dropdown-item" href="#">Another action</a> -->
                <div class="dropdown-divider"></div>
                <!-- <a class="dropdown-item" href="#">Something else here</a> -->
            </div>
        </div>
    </div>
    <!-- Card Body -->
    <div class="card-body">
       
       {% if not obj %}
            <div class="alert alert-info">No hay Categorías</div>           
       {% else %}

       <table class="table table-striped table-hover">
           <thead>
               <th>Id</th>
               <th>Descripción</th>
               <th>Estado</th>
               <th>F. Creado</th>
               <th>F. Modif.</th>
               <th class="all">Acciones</th>
           </thead>

           <tbody>
               
               {% for item in obj %}
                   <tr>
                       <td>{{ item.id }}</td>
                       <td>{{ item.descripcion }}</td>
                       <td>{{ item.estado | yesno:"Activo, Inactivo" }}</td>
                       <td>{{ item.fc | date:"d/m/Y H:i:s" }}</td>
                       <td>{{ item.fm | date:"d/m/Y H:i:s" }}</td>
                       <td>
                           <a href="{% url 'inv:categoria_edit' item.id %}" class="btn btn-warning btn-circle" role="button"><i class="far fa-edit"></i></a>
                           <a href="{% url 'inv:categoria_del' item.id %}" class="btn btn-danger btn-circle" role="button"><i class="far fa-trash-alt"></i></a>
                       </td>
                   </tr>
               {% endfor %}
                   
           </tbody>
       </table>
       {% endif %}

    </div>
</div>

{% endblock page_content %}

{% block js_page %}
<script>
    // llamamos el dataTables jQuery plugin
    // $(document).ready(function() {
    //     $('.table').DataTable();
    // });

    $(function() {
        $('.table').DataTable({
            // "pageLength": 3,
            "language": {
                "processing": "Procesando...",
                "lengthMenu": "Mostrar _MENU_ registros",
                "zeroRecords": "No se encontraron resultados",
                "emptyTable": "Ningún dato disponible en esta tabla",
                "infoEmpty": "Mostrando registros del 0 al 0 de un total de 0 registros",
                "infoFiltered": "(filtrado de un total de _MAX_ registros)",
                "search": "Buscar:",
                "infoThousands": ",",
                "loadingRecords": "Cargando...",
                "paginate": {
                    "first": "Primero",
                    "last": "Último",
                    "next": "Siguiente",
                    "previous": "Anterior"
                },
                "aria": {
                    "sortAscending": ": Activar para ordenar la columna de manera ascendente",
                    "sortDescending": ": Activar para ordenar la columna de manera descendente"
                }
            }
        });
    });
</script>
   
{% endblock js_page %}
    

inv/templates/inv/marca_list.html
{% extends 'base/base.html' %}

{% block page_content %}
 <!-- Dropdown Card Example -->
 <div class="card shadow mb-4">
    <!-- Card Header - Dropdown -->
    <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
        <h6 class="m-0 font-weight-bold text-primary">Listado de Marcas</h6>
        <div class="dropdown no-arrow">
            <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
            </a>
            <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
                <div class="dropdown-header">Acciones:</div>
                    <a class="dropdown-item" href="{% url 'inv:marca_new' %}"> <i class="fa fa-calendar-plus"></i> Nueva</a>
                    <!-- <a class="dropdown-item" href="#">Another action</a> -->
                <div class="dropdown-divider"></div>
                <!-- <a class="dropdown-item" href="#">Something else here</a> -->
            </div>
        </div>
    </div>
    <!-- Card Body -->
    <div class="card-body">
       
       {% if not obj %}
            <div class="alert alert-info">No hay Marca</div>           
       {% else %}

       <table class="table table-striped table-hover">
           <thead>
               <th>Id</th>
               <th>Descripción</th>
               <th>Estado</th>
               <th>F. Creado</th>
               <th>F. Modif.</th>
               <th class="all">Acciones</th>
           </thead>

           <tbody>
               
               {% for item in obj %}
                   <tr>
                       <td>{{ item.id }}</td>
                       <td>{{ item.descripcion }}</td>
                       <td>{{ item.estado | yesno:"Activo, Inactivo" }}</td>
                       <td>{{ item.fc | date:"d/m/Y H:i:s" }}</td>
                       <td>{{ item.fm | date:"d/m/Y H:i:s" }}</td>
                       <td>
                           <a href="{% url 'inv:marca_edit' item.id %}" class="btn btn-warning btn-circle" role="button"><i class="far fa-edit"></i></a>
                           <a href="{% url 'inv:marca_inactivar' item.id %}" class="btn btn-danger btn-circle" role="button"><i class="far fa-thumbs-down"></i></a>
                       </td>
                   </tr>
               {% endfor %}
                   
           </tbody>
       </table>
       {% endif %}

    </div>
</div>

{% endblock page_content %}

{% block js_page %}
<script>
    // llamamos el dataTables jQuery plugin
    $(function() {
        $('.table').DataTable({
            "language": {
                "processing": "Procesando...",
                "lengthMenu": "Mostrar _MENU_ registros",
                "zeroRecords": "No se encontraron resultados",
                "emptyTable": "Ningún dato disponible en esta tabla",
                "infoEmpty": "Mostrando registros del 0 al 0 de un total de 0 registros",
                "infoFiltered": "(filtrado de un total de _MAX_ registros)",
                "search": "Buscar:",
                "infoThousands": ",",
                "loadingRecords": "Cargando...",
                "paginate": {
                    "first": "Primero",
                    "last": "Último",
                    "next": "Siguiente",
                    "previous": "Anterior"
                },
                "aria": {
                    "sortAscending": ": Activar para ordenar la columna de manera ascendente",
                    "sortDescending": ": Activar para ordenar la columna de manera descendente"
                }
            }
        });
    });
</script>
   
{% endblock js_page %}
    

inv/templates/inv/producto_list.html
{% extends 'base/base.html' %}

{% block page_content %}
 <!-- Dropdown Card Example -->
 <div class="card shadow mb-4">
    <!-- Card Header - Dropdown -->
    <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
        <h6 class="m-0 font-weight-bold text-primary">Listado de Productos</h6>
        <div class="dropdown no-arrow">
            <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
            </a>
            <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
                <div class="dropdown-header">Acciones:</div>
                    <a class="dropdown-item" onclick="return abrir_modal('{% url 'inv:producto_new' %}')" href="#"> <i class="fa fa-calendar-plus"></i> Nuevo</a>
                    <!-- <a class="dropdown-item" href="#">Another action</a> -->
                <div class="dropdown-divider"></div>
                <!-- <a class="dropdown-item" href="#">Something else here</a> -->
            </div>
        </div>
    </div>
    <!-- Card Body -->
    <div class="card-body">
       
       {% if not obj %}
            <div class="alert alert-info">No hay Productos</div>           
       {% endif %}

       <table class="table table-striped table-hover dt-responsive nowrap" style="width: 100%;">
           <thead>
               <th>Id</th>
               <th>Sub.Cat.</th>
               <th>Código</th>
               <th>Barra</th>
               <th>Descripción</th>
               <th>Existencia</th>
               <th>Marca</th>
               <th>U.M</th>
               <th>Estado</th>
               <th class="all">Acciones</th>
           </thead>

           <tbody>               
               {% for item in obj %}
                   <tr>
                       <td>{{ item.id }}</td>
                       <td>{{ item.subcategoria }}</td>
                       <td>{{ item.codigo }}</td>
                       <td>{{ item.codigo_barra }}</td>
                       <td>{{ item.descripcion }}</td>
                       <td>{{ item.existencia }}</td>
                       <td>{{ item.marca }}</td>                       
                       <td>{{ item.unidad_medida }}</td>
                       <td>{{ item.estado|yesno:"Activo,Inactivo" }}</td>
                       <td>
                          <button class="btn btn-warning btn-circle" onclick="return abrir_modal('{% url 'inv:producto_edit' item.id %}')" href="#"><i class="far fa-edit"></i></button>
                        <a href="{% url 'inv:producto_inactivar' item.id %}" class="btn btn-danger btn-circle" role="button"><i class="far fa-thumbs-down"></i></a>
                       </td>
                   </tr>
               {% endfor %}
                   
           </tbody>
       </table>       

    </div>
</div>

{% endblock page_content %}

{% block js_page %}

    <script>
        // llamamos el dataTables jQuery plugin
        $(function() {
            $("#sidebarToggle").click();
            $('.table').DataTable({
                "language": {
                    "processing": "Procesando...",
                    "lengthMenu": "Mostrar _MENU_ registros",
                    "zeroRecords": "No se encontraron resultados",
                    "emptyTable": "Ningún dato disponible en esta tabla",
                    "infoEmpty": "Mostrando registros del 0 al 0 de un total de 0 registros",
                    "infoFiltered": "(filtrado de un total de _MAX_ registros)",
                    "search": "Buscar:",
                    "infoThousands": ",",
                    "loadingRecords": "Cargando...",
                    "paginate": {
                        "first": "Primero",
                        "last": "Último",
                        "next": "Siguiente",
                        "previous": "Anterior"
                    },
                    "aria": {
                        "sortAscending": ": Activar para ordenar la columna de manera ascendente",
                        "sortDescending": ": Activar para ordenar la columna de manera descendente"
                    }
                }
            });
        });
    </script>
    
{% endblock js_page%}
    